unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, GEOTRACKLib_TLB, Spin, Placemnt, ExtCtrls, RXSpin,
  Mask, StrUtils, ComCtrls, Menus, Buttons, Grids, IniFiles, TeEngine,
  Series, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Label4: TLabel;
    Label1: TLabel;
    Button3: TBitBtn;
    Button4: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Button5: TButton;
    Button6: TBitBtn;
    PortNumber: TRxSpinEdit;
    PortSpeed: TComboBox;
    Timer1: TTimer;
    FormStorage1: TFormStorage;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    SendCmdBtn: TButton;
    Label2: TLabel;
    AddressEdit: TEdit;
    Label3: TLabel;
    Parameters: TEdit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Splitter1: TSplitter;
    CmdGrid: TStringGrid;
    SerialMemo: TRichEdit;
    Chart1: TChart;
    Series2: TFastLineSeries;
    Series3: TFastLineSeries;
    Series1: TFastLineSeries;
    Series4: TFastLineSeries;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PortNumberChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure CmdGridDblClick(Sender: TObject);
    procedure SendCmdBtnClick(Sender: TObject);
    procedure ParametersChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AppendString(S: String; C: TColor);
    procedure AppendHexString(S: String; C: TColor);
  end;
function OpenComm(InQueue, OutQueue, ComPort, Baud: LongInt): Boolean;
function SetCommTiming: Boolean;
function SetCommBuffer(InQueue, OutQueue: LongInt): Boolean;
function SetCommStatus(Baud: Integer): Boolean;
function SendCommStr(S: String): Integer;
function ReadCommStr(var S: String): Integer;
procedure CloseComm;

const
  CPort: array [1..4] of String =('COM1:','COM2:','COM3:','COM4:');

type
  TParam=record
    Name: String;
    Value: Variant;
  end;
var
  Form1: TForm1;
  Com: THandle;
  InBuff, OutBuff: array[0..255] of char;
  ReadedString, IniFName: String;
  CallingFlag: Boolean=False;
  OpenedComPort: Integer=0;
  FormCreated: Boolean=False;
  ParamsCount: Integer=0;
  Params: array[1..50] of TParam;

implementation

{$R *.DFM}

function OpenComm(InQueue, OutQueue, ComPort, Baud: LongInt): Boolean;
begin
  if {Com<>INVALID_HANDLE_VALUE}OpenedComPort<>0 then CloseComm;
  Com := CreateFile(PChar(CPort[ComPort]), GENERIC_READ or GENERIC_WRITE,
                    0, nil, OPEN_EXISTING, 0{FILE_ATTRIBUTE_NORMAL}, 0);
{  SetCommTiming;
  SetCommBuffer(InQueue,OutQueue);
  SetCommStatus(Baud);}
  Result := (Com<>INVALID_HANDLE_VALUE) and SetCommTiming and
//            SetCommBuffer(InQueue,OutQueue) and
            SetCommStatus(Baud);
  if Result then begin
    Form1.AppendString('Port COM'+IntToStr(ComPort)+': is Opened',clGreen);
    OpenedComPort:=ComPort;
  end else Form1.AppendString('Port COM'+IntToStr(ComPort)+': is Busy',clGreen);
end;

function SetCommTiming: Boolean;
var Timeouts: TCommTimeOuts;
begin
  with TimeOuts do begin
    ReadIntervalTimeout := 1;
    ReadTotalTimeoutMultiplier := 0;
    ReadTotalTimeoutConstant := 1;
    WriteTotalTimeoutMultiplier := 2;
    WriteTotalTimeoutConstant := 2;
  end;
  Result := SetCommTimeouts(Com,Timeouts);
end;

function SetCommBuffer(InQueue, OutQueue: LongInt): Boolean;
begin
  Result := SetupComm(Com, InQueue, OutQueue);
end;

function SetCommStatus(Baud: Integer): Boolean;
var DCB: TDCB;
begin
  with DCB do begin
    DCBlength:=SizeOf(Tdcb);
    BaudRate := Baud;
    Flags:=12305;
    wReserved:=0;
    XonLim:=600;
    XoffLim:=150;
    ByteSize:=8;
    Parity:=0;
    StopBits:=0;
    XonChar:=#17;
    XoffChar:=#19;
    ErrorChar:=#0;
    EofChar:=#0;
    EvtChar:=#0;
    wReserved1:=65;
  end;
  Result := SetCommState(Com, DCB);
end;

function SendCommStr(S: String): Integer;
var TempArray: array[1..255] of Byte;
    Count, TX_Count: Cardinal;
begin
  for Count := 1 to Length(S) do TempArray[Count] := Ord(S[Count]);
  WriteFile(Com, TempArray, Length(S), TX_Count, nil);
  Form1.AppendHexString(S,clRed);
  Result := TX_Count;
end;

function ReadCommStr(var S: String) : Integer;
var TempArray: array[1..255] of Byte;
    Count, RX_Count: Cardinal;
begin
  S := '';
  ReadFile(Com, TempArray, 255, RX_Count, nil);
  for Count := 1 to RX_Count do S := S + Chr(TempArray[Count]);
  if S<>'' then Form1.Edit1.Text:=S;
  Form1.AppendHexString(S,clBlue);
  Result := RX_Count;
end;

procedure CloseComm;
begin
  if (Com<>INVALID_HANDLE_VALUE) then begin
    if (OpenedComPort<>0) then
      Form1.AppendString('Port COM'+IntToStr(OpenedComPort)+': is Closed',clGreen);
    CloseHandle(Com);
    OpenedComPort:=0;
  end;
  Com := INVALID_HANDLE_VALUE;
end;

procedure TForm1.FormCreate(Sender: TObject);
var I,K,X,Y: Integer; S: String;
begin
  IniFName:=ChangeFileExt(ParamStr(0),'.ini');
  FormStorage1.IniFileName:=IniFName;
  PortSpeed.Text:='9600';
  FormStorage1.RestoreFormPlacement;
  Button3.Click;
  with TIniFile.Create(IniFName) do begin
    with CmdGrid do begin
      K:=6;
      for I:=K to CmdGrid.ColCount-1 do Cells[I,0]:=IntToStr(I-K+1);
      ColWidths[0]:=110;
      ColWidths[1]:=200;
      ColWidths[2]:=200;
      ColWidths[3]:=50;
      ColWidths[4]:=50;
      ColWidths[5]:=50;
      Cells[0,0]:='Description';
      Cells[1,0]:='Command';
      Cells[2,0]:='Response';
      Cells[3,0]:='Var1';
      Cells[4,0]:='Var2';
      Cells[5,0]:='Var3';
      for Y:=1 to RowCount-1 do begin
        S:=ReadString('Main','Command'+IntToStr(Y),'');
        for X:=0 to WordCount(S,[';'])-1 do
          Cells[X,Y]:=ExtractWord(X+1,S,[';']);
      end;
    end;
    Free;
  end;
  FormCreated:=True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var X,Y: Integer; S,S1: String;
begin
  Button6.Click;
  with TIniFile.Create(IniFName) do begin
    with CmdGrid do begin
      for Y:=1 to RowCount-1 do begin
        S:='';
        for X:=0 to ColCount-1 do begin
          S1:=Cells[X,Y]; if S1='' then S1:=' ';
          S:=S+S1+';';
        end;
        SetLength(S,Length(S)-1);
        WriteString('Main','Command'+IntToStr(Y),S);
      end;
    end;
    Free;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  OpenComm(Integer(@InBuff),Integer(@OutBuff),Round(PortNumber.Value),CBR_9600);
  if Com<>INVALID_HANDLE_VALUE
    then StatusBar1.Panels[0].Text:='COM'+IntToStr(Round(PortNumber.Value))+': is Opened'
    else StatusBar1.Panels[0].Text:='COM'+IntToStr(Round(PortNumber.Value))+': is Busy';
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  SendCommStr(Edit2.Text);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ReadCommStr(ReadedString);
  Edit1.Text:=ReadedString;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
//  try CloseHandle(Com); except end;
  CloseComm;
  StatusBar1.Panels[0].Text:='COM-Port Closed';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (Com<>INVALID_HANDLE_VALUE) then begin
    ReadCommStr(ReadedString);
  end;
end;

procedure TForm1.PortNumberChange(Sender: TObject);
begin
  Button6.Click;
  Button3.Click;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  FormStorage1.SaveFormPlacement;
end;

function Str2Hex(S: String): String;
var I: Integer;
begin
  Result:='';
  for I:=1 to Length(S) do Result:=Result+Dec2Hex(Byte(S[I]),2)+' ';
end;

procedure TForm1.AppendString(S: String; C: TColor);
var PrevActiveControl: TWinControl;
begin
  if S<>'' then with SerialMemo do begin
    if Lines.Count=0 then Clear;
    SelAttributes.Color:=C;
    Lines.Add(S);
    if FormCreated then begin
      PrevActiveControl:=ActiveControl;
      SerialMemo.SetFocus;
      SerialMemo.SelStart:=1000000;
      PrevActiveControl.SetFocus;
    end;
  end;
end;

procedure TForm1.AppendHexString(S: String; C: TColor);
begin
  AppendString(Str2Hex(S),C);
end;

procedure TForm1.CmdGridDblClick(Sender: TObject);
begin
  SendCmdBtn.Click;
end;

procedure SendCommand(S: String);
var I,J,K,N,L,LByte,LBytes,CRCByte,CRCBytes,CRC,BytesPerVar,VarIndex,VarValue: Integer;
    S2,StrToSend: String;
    C: Char; InParams: Boolean;
begin
  StrToSend:=''; CRCByte:=0; LByte:=0; VarIndex:=0;
  N:=WordCount(S,[' ']);
  for I:=1 to N do begin
    S2:=ExtractWord(I,S,[' ']);
    if (S2<>'') and (S2[1]>='0') and (S2[1]<='9') then //   
      StrToSend:=StrToSend+Char(Hex2Dec(S2))
    else with Form1 do begin
      if S2='A' then                                   //  
        StrToSend:=StrToSend+Char(Hex2Dec(AddressEdit.Text))
      else if S2='L' then begin                        //  
        LByte:=I; LBytes:=1;
        StrToSend:=StrToSend+Char(N)
      end else if S2='CRC' then begin                  // CRC
        CRCByte:=I; CRCBytes:=1;
        StrToSend:=StrToSend+#0;
      end else if NPos('[',S2,1)<>0 then begin         //  
      end else begin                                   // 
        InParams:=False;
        for J:=1 to ParamsCount do
          if Params[J].Name=S2 then begin
            InParams:=True;
            if (VarType(Params[J].Value) and VarTypeMask)=varString
              then StrToSend:=StrToSend+Params[J].Value
              else StrToSend:=StrToSend+IntToStr(Params[J].Value);
            break;
          end;
        if not InParams then begin
          Inc(VarIndex);
          C:=S2[Length(S2)];
          if (C>='0') and (C<='9') then BytesPerVar:=StrToInt(C)
                                   else BytesPerVar:=1;
          with Form1.CmdGrid do VarValue:=StrToInt(Cells[2+VarIndex,Row]);
          for J:=1 to BytesPerVar do
            StrToSend:=StrToSend+Char(VarValue); VarValue:=VarValue shr 8;
        end;
      end;
    end;
  end;
  L:=Length(StrToSend); N:=L;                          //   
  if LByte<>0 then for I:=0 to LBytes-1 do begin       // (  )
    StrToSend[LByte+I]:=Char(N); N:=N shr 8;
  end;
  CRC:=0;                                              //  
  for I:=1 to L do Inc(CRC,Byte(StrToSend[I]));        //  CRC
  if CRCByte<>0 then for I:=0 to CRCBytes-1 do begin   // (  )
    StrToSend[CRCByte+I]:=Char(CRC); CRC:=CRC shr 8;
  end;
  SendCommStr(StrToSend);
end;

procedure TForm1.SendCmdBtnClick(Sender: TObject);
var I,N: Integer; S, ParStr: String;
begin
  with CmdGrid do begin
    N:=0; ParStr:='';
    for I:=3 to 10 do begin
      S:=DelSpace(Cells[I,Row]);
      if S='' then break else ParStr:=ParStr+','+S;
    end;
    if ParStr<>'' then begin
      ParStr[1]:='('; ParStr:=' '+ParStr+')';
    end;
    AppendString('// '+Cells[0,Row]+ParStr+' :',clTeal);
    SendCommand(Cells[1,Row]);
  end;
end;

procedure TForm1.ParametersChange(Sender: TObject);
var I,N,K: Integer; S,S1,S2: String;
begin
  N:=WordCount(Parameters.Text,[' ']);
  K:=0;
  for I:=1 to N do begin
    S:=ExtractWord(I,S,[' ']);
    S1:=ExtractWord(1,S,[':']);
    S2:=ExtractWord(2,S,[':']);
    if (S1<>'') and (S2<>'') then begin
      Inc(K);
      Params[K].Name:=S1;
      if (S2[1]>='0') and (S2[1]<='9') then begin
        Params[K].Value:=StrToInt(S2);
      end else if (S2[1]='$') and (Length(S2)>=2) then begin
        Params[K].Value:=Hex2Dec(Copy(S2,2,Length(S2)-1));
      end else begin
        Params[K].Value:=S2;
      end;
    end;
  end;
  ParamsCount:=K;
end;

end.
